// إå
#include <EnemyAttack.H>
#include <Enemy.H>

/* ##################################################################
   Attributes
   ################################################################## */

const Obj::Attr Enemy1::attr	(1, DVector(0.8, 0.8), 10,  200,  10);
const Obj::Attr Enemy1a::attr	(1, DVector(0.8, 0.8), 10,  200,  10);
const Obj::Attr Enemy2::attr	(1, DVector(0.8, 0.8), 10,  500,  10);
const Obj::Attr Enemy3::attr	(1, DVector(0.8, 0.8), 10,  200,  10);
const Obj::Attr Enemy4::attr	(1, DVector(0.8, 0.8), 10,  100,  10);
const Obj::Attr EnemyI::attr	(1, DVector(0.8, 0.8), 10, 5000, 150);
const Obj::Attr EnemyII::attr	(1, DVector(0.8, 0.8), 10, 6000, 150);
const Obj::Attr EnemyIII::attr	(1, DVector(0.8, 0.8), 10, 3000, 150);
const Obj::Attr EnemyIIIa::attr	(1, DVector(0.8, 0.8), 10, 3000, 150);
const Obj::Attr EnemyIV::attr	(1, DVector(0.8, 0.8), 10, 5000, 150);
const Obj::Attr Rock::attr	(1, DVector(1.0, 1.0), 10,  200,  10);

/* ##################################################################
   Enemy1
   ################################################################## */

Enemy1::Enemy1(const int i, const DVector & l) : Enemy(NULL, &enemy1PxRn[0], l, dzero, dzero, DEPTH_ENEMY), fin(NULL), phase(init), stepSleep(i) {
    fin = new Part(this,&enemy1PxRn[1], dzero, dzero, dzero, 
		   DEPTH_ENEMY_BACK, 0);
}

const Obj::Attr &Enemy1::getAttr(void) const { return attr; }

void Enemy1::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run1;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	  case run1:
	    if (viewSize.x / 4 < locate.x) break;
	    phase = run2;
	    step = 0;
	    vector = DVector(4 ,(locate.y < viewSize.y / 2) ? 3 : -3);
	    continue;	    
	  case run2:
	    if (Ship::ship()) {
		if (Ship::ship()->locate.y < locate.y && vector.y < 0) break;
		if (locate.y < Ship::ship()->locate.y && 0 < vector.y) break;
	    }
	    phase = run3;
	    step = 0;
	    vector = DVector(9 ,0);
	    continue;	    	    
	  case run3:
	    break;
	}
	break;
    }

    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run1:
	direct += 5;
	fin->reldirect += 5;
	if (!localRand(fps * 2) && Ship::ship()) {
	    new EnemyShell(locate, Ship::ship()->locate);
	}
	break;
      case run2:
	direct += 5;	
	fin->reldirect += 5;	
	if (!localRand(fps * 2) && Ship::ship()) {
	    new EnemyShell(locate, Ship::ship()->locate);
	}
	break;
      case run3:
	direct += 5;
	fin->reldirect += 5;
	if (fps < step && !inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;    
    step++;
}

// Enemy1a

Enemy1a::Enemy1a(const int i, const DVector & l) : Enemy(NULL, &enemy1PxRn[0], l, dzero, dzero, DEPTH_ENEMY), phase(init), stepSleep(i) {
    fin = new Part(this,&enemy1PxRn[1], dzero, dzero, dzero, 
		   DEPTH_ENEMY_BACK, 0);
}

const Obj::Attr &Enemy1a::getAttr(void) const { return attr; }

void Enemy1a::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    vdirect = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run1;
	    step = 0;
	    if (locate.y < viewSize.y / 2) {
		vector = DVector(0,14);
	    } else {
		vector = DVector(0,-14);		
	    }
	    continue;
	  case run1:
	    if (step < 16) break;
	    phase = run2;
	    step = 0;
	    vector = DVector(8 + localRand(3) * 2, 0);
	    vdirect = (locate.y < viewSize.y / 2) ? 90 : 270;
	    continue;
	  case run2:
	    break;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run1:
	direct += 5;
	fin->reldirect += 5;	
	if (0 < vector.y) {
	    vector.y -= 1;
	} else if (vector.y < 0) {
	    vector.y += 1;
	}
	break;
      case run2:
	direct += 5;
	fin->reldirect += 5;	
	if (vdirect != 180) {
	    vdirect += (180 < vdirect) ? -5 : 5;
	    if (!localRand(fps) && Ship::ship()) {
		new EnemyShell(locate, Ship::ship()->locate);
	    }	
	}
	if (!inView()) {
	    isAlive = 0;
	    return;
	}	
	break;	
    }
    locate += vector % vdirect;
    step++;
}

/* ##################################################################
   Enemy2
   ################################################################## */

Enemy2::Enemy2(const int i, const DVector & l) : Enemy(NULL, &enemy2Px, l, dzero, dzero, DEPTH_ENEMY_FRONT), phase(init), stepSleep(i) {
}

const Obj::Attr &Enemy2::getAttr(void) const { return attr; }

void Enemy2::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run1;
	    step = 0;
	    vector = DVector(-12,0);
	    continue;
	  case run1:
	    if (viewSize.x / 4 < locate.x) break;
	    phase = run2;
	    step = 0;
	    vector = DVector(9,0);
	    continue;
	  case run2:
	    if (locate.x < viewSize.x * 3 / 4) break;
	    phase = run3;
	    step = 0;
	    vector = DVector(-12,0);
	    continue;	    
	  case run3:
	    break;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run1:
	vector.y = 8 * cos((2*M_PI*step)/36);
	break;
      case run2:
	vector.y = 8 * cos((2*M_PI*step)/36);
	if (!localRand(fps) && Ship::ship()) {
	    new EnemyMissile3(Ship::ship(),
			      locate, 0, DVector(3, localRand(7) - 3));
	}
	break;
      case run3:
	vector.y = 8 * cos((2*M_PI*step)/36);
	if (fps < step && !inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;
    step++;
}

/* ##################################################################
   Enemy3
   ################################################################## */

Enemy3::Enemy3(const int i, const DVector & l) : Enemy(NULL, &enemy3PxRn, l, dzero, dzero, DEPTH_ENEMY), phase(init), stepSleep(i) {
}

const Obj::Attr &Enemy3::getAttr(void) const { return attr; }

void Enemy3::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run1;
	    step = 0;
	    if (locate.y < viewSize.y / 2) {
		vector = DVector(0,14);
	    } else {
		vector = DVector(0,-14);		
	    }
	    continue;
	  case run1:
	    if (step < 16) break;
	    phase = idle;
	    step = 0;
	    vector = dzero;
	    continue;
	  case idle:
	    if (step < fps / 8) break;
	    phase = run2;
	    step = 0;
	    vector.x = - double(localRand(3) + 1) / 4;
	    vector.y = (localRand(int(viewSize.y)) - locate.y) / viewSize.y;
	    break;
	  case run2:
	    if (step < fps / 4) break;
	    phase = idle;
	    step = 0;
	    vector = dzero;
	    break;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run1:
	if (0 < vector.y) {
	    vector.y -= 1;
	} else if (vector.y < 0) {
	    vector.y += 1;
	}
	break;
      case idle:
	direct += 10;	
	if (!inView()) {
	    isAlive = 0;
	    return;
	}	
	break;
      case run2:
	direct += 10;
	vector *= 2;
	if (!inView()) {
	    isAlive = 0;
	    return;
	}	
	break;	
    }
    locate += vector;    
    step++;
}

/* ##################################################################
   Enemy4
   ################################################################## */

Enemy4::Enemy4(const int i, const int d, const DVector &l, const DVector &v) : Enemy(NULL, &enemy4PxRn, l, dzero, dzero, DEPTH_ENEMY), phase(init), vector(v), stepDead(d), stepSleep(i) {}

const Obj::Attr &Enemy4::getAttr(void) const { return attr; }

void Enemy4::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run;
	    step = 0;
	    continue;
	  case run:
	    break;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run:
	direct += 10;
	if (step == stepDead) {
	    direct = 180;
	    if (Ship::ship()) setDirect(Ship::ship()->locate, 5);
	    new EnemyMissile(locate, direct - 24);
	    new EnemyMissile(locate, direct -  8);
	    new EnemyMissile(locate, direct +  8);
	    new EnemyMissile(locate, direct + 24);
	    isAlive = 0;
	    return;
	}
	locate += vector;    
	break;	
    }
    step++;
}

/* ##################################################################
   EnemyI
   ################################################################## */

EnemyI::EnemyI(const DVector & l) : Enemy(NULL, &enemyIPx[0], l, dzero, dzero, DEPTH_ENEMY), phase(init) {
    parts[0][0][0] = new Part(this, &enemyIPx[1],
			      DVector(-20,-36), dzero, dzero,
			      DEPTH_ENEMY_FRONT);
    parts[0][0][1] = new Part(parts[0][0][0], &enemyIPx[2],
			      dzero, dzero, dzero,
			      DEPTH_ENEMY,0);
    parts[0][1][0] = new Part(parts[0][0][0], &enemyIPx[1],
			      DVector(-8,-36), dzero, dzero,
			      DEPTH_ENEMY_FRONT,0);
    parts[0][1][1] = new Part(parts[0][1][0], &enemyIPx[2],
			      dzero, dzero, dzero,
			      DEPTH_ENEMY,0);
    parts[1][0][0] = new Part(this, &enemyIPx[1],
			      DVector(-20,36), dzero, dzero,
			      DEPTH_ENEMY_FRONT,0);
    parts[1][0][1] = new Part(parts[1][0][0], &enemyIPx[2],
			      dzero, dzero, dzero,
			      DEPTH_ENEMY,0);    
    parts[1][1][0] = new Part(parts[1][0][0], &enemyIPx[1],
			      DVector(-8,36), dzero, dzero,
			      DEPTH_ENEMY_FRONT);
    parts[1][1][1] = new Part(parts[1][1][0], &enemyIPx[2],
			      dzero, dzero, dzero,
			      DEPTH_ENEMY,0);
}

const Obj::Attr &EnemyI::getAttr(void) const { return attr; }

void EnemyI::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	  case cruise:
	    if (viewSize.x * 5 / 6 < locate.x) break;
	    phase = trans1;
	    step = 0;
	    vbase = DVector(0,localRand(2) ? 16 : -16);
	    vector = dzero;
	    continue;
	  case trans1:
	    if (step < 8) break;
	    phase = idle;
	    step = 0;
	    continue;
	  case idle:
	    if (step < 16) break;
	    phase = trans2;
	    step = 0;
	    continue;
	  case trans2:
	    if (step < 8) break;
	    phase = move;
	    step = 0;
	    vector = vbase;
	    continue;
	  case move:
	    if (vector.y) break;
	    phase = trans1;
	    step = 0;
	    continue;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
      case cruise:
	break;
      case idle:
      case trans1:
      case trans2:
      case move:
	if (step == 0 && Ship::ship()) {
	    new EnemyMissile3(Ship::ship(),
			      locate, 0, DVector(2, vector.y / 3));
	}
	break;
    }
    switch (phase) {
      case init:
	break;
      case cruise:
	break;
      case trans1:
	parts[0][0][0]->rellocate += DVector(2,0);
	parts[0][0][1]->rellocate += DVector(-6,0);
	parts[0][1][0]->rellocate += DVector(2,0);
	parts[0][1][1]->rellocate += DVector(-6,0);
	parts[1][0][0]->rellocate += DVector(2,0);
	parts[1][0][1]->rellocate += DVector(-6,0);
	parts[1][1][0]->rellocate += DVector(2,0);
	parts[1][1][1]->rellocate += DVector(-6,0);
	break;
      case idle:
	if (step == 8) {
	    new EnemyLaser(parts[0][0][1], DVector(-28,0));
	    new EnemyLaser(parts[0][1][1], DVector(-28,0));
	    new EnemyLaser(parts[1][0][1], DVector(-28,0));
	    new EnemyLaser(parts[1][1][1], DVector(-28,0));
	}
	break;
      case trans2:
	parts[0][0][0]->rellocate += DVector(-2,0);
	parts[0][0][1]->rellocate += DVector(6,0);
	parts[0][1][0]->rellocate += DVector(-2,0);
	parts[0][1][1]->rellocate += DVector(6,0);
	parts[1][0][0]->rellocate += DVector(-2,0);
	parts[1][0][1]->rellocate += DVector(6,0);
	parts[1][1][0]->rellocate += DVector(-2,0);
	parts[1][1][1]->rellocate += DVector(6,0);	
	break;
      case move:
	if (locate.y < viewSize.y / 8 ||
	    locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;
    }
    locate += vector;    
    step++;
}

/* ##################################################################
   EnemyII
   ################################################################## */

EnemyII::EnemyII(const DVector & l) : Enemy(NULL, &enemyIPx[0], l, dzero, dzero, DEPTH_ENEMY_FRONT), phase(init) {
    parts[0][0] = new Part(this, &enemyIIPxRn[2],
			   DVector(0,-20), dzero, DVector(34,0),
			   DEPTH_ENEMY);
    parts[0][1] = new Part(parts[0][0], &enemyIIPxRn[2],
			   dzero, dzero, DVector(34,0),
			   DEPTH_ENEMY,180);
    parts[0][2] = new Part(parts[0][1], &enemyIIPxRn[0],
			   dzero, dzero, DVector(34,0),
			   DEPTH_ENEMY_BACK,180);
    parts[1][0] = new Part(this, &enemyIIPxRn[1],
			   DVector(0,20), dzero, DVector(34,0),
			   DEPTH_ENEMY,0);
    parts[1][1] = new Part(parts[1][0], &enemyIIPxRn[1],
			   dzero, dzero, DVector(34,0),
			   DEPTH_ENEMY,180);
    parts[1][2] = new Part(parts[1][1], &enemyIIPxRn[0],
			   dzero, dzero, DVector(34,0),
			   DEPTH_ENEMY_BACK,180);
}

const Obj::Attr &EnemyII::getAttr(void) const { return attr; }

void EnemyII::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	  case cruise:
	    if (viewSize.x * 7 / 8 < locate.x) break;
	    phase = trans1;
	    step = 0;
	    vbase = DVector(0,localRand(2) ? 16 : -16);	    
	    vector = dzero;
	    continue;
	  case trans1:
	    if (step < 18) break;
	    phase = idle;
	    step = 0;
	    continue;
	  case idle:
	    if (step < 16) break;
	    phase = trans2;
	    step = 0;
	    continue;
	  case trans2:
	    if (step < 36) break;
	    phase = move;
	    step = 0;
	    vector = vbase;
	    continue;
	  case move:
	    if (vector.y) break;
	    phase = trans1;
	    step = 0;
	    continue;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case cruise:
	break;
      case trans1:
	if (15 - 9 <= step && step < 15) {
	    parts[0][0]->reldirect -= 10;
	    parts[1][0]->reldirect += 10;
	}
	if (15 - 12  <= step && step < 15) {
	    parts[0][1]->reldirect += 10;
	    parts[1][1]->reldirect -= 10;
	}
	if (step < 15) {
	    parts[0][2]->reldirect += 10;
	    parts[1][2]->reldirect -= 10;
	}
	if (9 <= step & step <= 15) {
	    for (int i = 0; i < 2; i ++) {
		Part &p = *parts[i][2];
		new EnemyShell(p.joint, p.direct - 2, 10);
		new EnemyShell(p.joint, p.direct + 2, 12);		
	    }
	}
	break;
      case idle:
	break;
      case trans2:
	if (step < 15) {
	    parts[0][2]->reldirect -= 10;
	    parts[1][2]->reldirect += 10;
	}
	if (15 <= step && step < 15 + 12) {
	    parts[0][1]->reldirect -= 10;
	    parts[1][1]->reldirect += 10;
	}
	if (15 + 12 <= step && step < 15 + 12 + 9) {
	    parts[0][0]->reldirect += 10;
	    parts[1][0]->reldirect -= 10;
	}
	break;
      case move:
	if (locate.y < viewSize.y / 8 ||
	    locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;
    }
    locate += vector;    
    step++;
}

/* ##################################################################
   EnemyIII
   ################################################################## */

EnemyIII::EnemyIII(const DVector & l) : Enemy(NULL, &enemyIIIPxRn[0], l, dzero, dzero, DEPTH_ENEMY_FRONT), phase(init) {
    head = new Part(this, &enemyIIIPxRn[0],
		    DVector(0,-24), dzero, dzero,
		    DEPTH_ENEMY_BACK,180);
    tail = new Part(this, &enemyIIIPxRn[0],
		    DVector(0,24), dzero, dzero,
		    DEPTH_ENEMY_BACK,180);
    new Part(this, &enemyIIIPxRn[1],
	     DVector(24,0), dzero, dzero,
	     DEPTH_ENEMY_BACK);
}

const Obj::Attr &EnemyIII::getAttr(void) const { return attr; }

void EnemyIII::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	  case cruise:
	    if (viewSize.x * 5 / 6 < locate.x) break;
	    phase = move;
	    step = 0;
	    vbase = DVector(0,localRand(2) ? 16 : -16);	    
	    vector = dzero;
	    continue;
	  case idle:
	    if (step < fps / 2) break;
	    phase = move;
	    step = 0;
	    vector = vbase;
	    continue;
	  case move:
	    if (vector.y) break;
	    switch (localRand(2) + 1) {
	      case 1:
		phase = mode1_trans1;
		vector = vbase;
		break;
	      case 2:
		phase = mode2_trans1;
		break;
	    }
	    step = 0;
	    continue;

	    // mode 1
	  case mode1_trans1:
	    if (vector.y) break;
	    phase = mode1_trans2;
	    step = 0;
	    continue;
	  case mode1_trans2:
	    if (direct != 0) break;
	    phase = idle;
	    step = 0;
	    continue;

	    // mode 2
	  case mode2_trans1:
	    if (step < 9) break;
	    phase = mode2_trans2;
	    step = 0;
	    continue;
	  case mode2_trans2:
	    if (step < 9) break;
	    phase = idle;
	    step = 0;
	    continue;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case cruise:
	break;
      case idle:
	break;
      case move:
	if (locate.y < viewSize.y / 8 || locate.y > viewSize.y * 7 / 8) {
	    vbase.y = - vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;

	// mode 1
      case mode1_trans1:
	if (Ship::ship()) adjustDirect(Ship::ship()->locate,5,180);
	if (step % 2)
	  new EnemyShell(head->joint + DVector(12, 0) % head->direct,
			 head->direct + localRand(10));
	else
	  new EnemyShell(tail->joint + DVector(12, 0) % tail->direct,
			 tail->direct - localRand(10));
	if (locate.y < viewSize.y / 8 ||
	    locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;
      case mode1_trans2:
	if (direct != 0)
	  direct += (direct < 0) ? 5 : -5;
	break;

	// mode 2
      case mode2_trans1:
	new EnemyShell(head->joint + DVector(12, 0) % head->direct,
		       head->direct + localRand(5));
	new EnemyShell(tail->joint + DVector(12, 0) % tail->direct,
		       tail->direct - localRand(5));
	head->reldirect += -10;
	tail->reldirect += 10;
	break;
      case mode2_trans2:
	new EnemyShell(head->joint + DVector(12, 0) % head->direct,
		       head->direct + localRand(5));
	new EnemyShell(tail->joint + DVector(12, 0) % tail->direct,
		       tail->direct - localRand(5));
	head->reldirect += 10;
	tail->reldirect += -10;
	break;
    }
    locate += vector;    
    step++;
}

// EnemyIIIa

EnemyIIIa::EnemyIIIa(const DVector & l) : Enemy(NULL, &enemyIIIPxRn[0], l, dzero, dzero, DEPTH_ENEMY_FRONT), phase(init) {
    head = new Part(this, &enemyIIIPxRn[0],
		    DVector(0,-24), dzero, dzero,
		    DEPTH_ENEMY_BACK,180);
    tail = new Part(this, &enemyIIIPxRn[0],
		    DVector(0,24), dzero, dzero,
		    DEPTH_ENEMY_BACK,180);
    new Part(head, &enemyIIIPxRn[1],
	     DVector(-24,0), dzero, dzero,
	     DEPTH_ENEMY_BACK,180);
    new Part(tail, &enemyIIIPxRn[1],
	     DVector(-24,0), dzero, dzero,
	     DEPTH_ENEMY_BACK, 180);
}

const Obj::Attr &EnemyIIIa::getAttr(void) const { return attr; }

void EnemyIIIa::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	  case cruise:
	    if (viewSize.x * 5 / 6 < locate.x) break;
	    phase = move;
	    step = 0;
	    vbase = DVector(0,localRand(2) ? 16 : -16);	    
	    vector = dzero;
	    continue;
	  case idle:
	    if (step < fps / 2) break;
	    phase = move;
	    step = 0;
	    vector = vbase;
	    continue;
	  case move:
	    if (vector.y) break;
	    switch (localRand(2) + 1) {
	      case 1:
		phase = mode1_trans1;
		vector = vbase;
		break;
	      case 2:
		phase = mode2_trans1;
		break;
	    }
	    step = 0;
	    continue;

	    // mode 1
	  case mode1_trans1:
	    if (vector.y) break;
	    phase = mode1_trans2;
	    step = 0;
	    continue;
	  case mode1_trans2:
	    if (direct != 0) break;
	    phase = idle;
	    step = 0;
	    continue;
	    
	    // mode 2
	  case mode2_trans1:
	    if (step < 9) break;
	    phase = mode2_trans2;
	    step = 0;
	    continue;
	  case mode2_trans2:
	    if (step < 18) break;
	    phase = mode2_trans3;
	    step = 0;
	    continue;
	  case mode2_trans3:
	    if (step < 9) break;
	    phase = idle;
	    step = 0;
	    continue;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case cruise:
	break;
      case idle:
	break;
      case move:
	if (locate.y < viewSize.y / 8 || locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;

	// mode 1
      case mode1_trans1:
	if (Ship::ship()) adjustDirect(Ship::ship()->locate,5,180);
	if (step % 2)
	  new EnemyShell(head->joint + DVector(12, 0) % head->direct,
			 head->direct + localRand(10));
	else 
	  new EnemyShell(tail->joint + DVector(12, 0) % tail->direct,
			 tail->direct - localRand(10));
	if (locate.y < viewSize.y / 8 ||
	    locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;
      case mode1_trans2:
	if (direct != 0)
	  direct += (direct < 0) ? 5 : -5;
	break;

	// mode 2
      case mode2_trans1:
	direct += 10;
	break;
      case mode2_trans2:
	direct -= 10;
	new EnemyShell(head->joint + DVector(12, 0) % head->direct, 
		       head->direct + localRand(5), 14);
	new EnemyShell(tail->joint + DVector(12, 0) % tail->direct,
		       tail->direct - localRand(5), 16);
	break;
      case mode2_trans3:
	direct += 10;
	break;
    }
    locate += vector;    
    step++;
}

/* ##################################################################
   EnemyIV
   ################################################################## */

EnemyIV::EnemyIV(const DVector & l) : Enemy(NULL, &enemyIIIPxRn[0], l, dzero, dzero, DEPTH_ENEMY_FRONT), phase(init) {
    head = new Part(this, &enemyIVPx,
		    DVector(0,-40), dzero, dzero,
		    DEPTH_ENEMY_BACK);
    tail = new Part(this, &enemyIVPx,
		    DVector(0,40), dzero, dzero,
		    DEPTH_ENEMY_BACK);
    new Part(head, &enemyIIIPxRn[1],
	     DVector(32,0), dzero, dzero,
	     DEPTH_ENEMY);
    new Part(tail, &enemyIIIPxRn[1],
	     DVector(32,0), dzero, dzero,
	     DEPTH_ENEMY);
}

const Obj::Attr &EnemyIV::getAttr(void) const { return attr; }

void EnemyIV::onFlush(void) {
    
    // 
    for (;;) {
	switch (phase) {
	    
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(-6,0);
	    continue;
	    
	  case cruise:
	    if (viewSize.x * 3 / 4 < locate.x) break;
	    phase = move;
	    step = 0;
	    vbase = DVector(0,localRand(2) ? 16 : -16);	    
	    vector = dzero;
	    continue;
	    
	  case idle:
	    if (step < fps / 2) break;
	    phase = move;
	    step = 0;
	    vector = vbase;
	    continue;
	    
	  case move:
	    if (vector.y) break;
	    switch (localRand(3) + 1) {
	      case 1:
		phase = fire1;
		break;
	      case 2:
		phase = fire2;
		break;
	      case 3:
		phase = fire3;
		break;
	    }
	    step = 0;
	    continue;
	    
	  case fire1:
	    if (step < fps / 2) break;
	    phase = idle;
	    step = 0;
	    continue;
	    
	  case fire2:	    
	    if (step < fps) break;
	    phase = idle;
	    step = 0;
	    continue;
	    
	  case fire3:
	    if (step < fps) break;
	    phase = idle;
	    step = 0;
	    continue;
	}
	break;
    }
    
    // 
    switch (phase) {
	
      case init:
	break;
      case cruise:
	break;
      case idle:
	break;

	// ư
      case move:
	if (locate.y < viewSize.y / 8 || locate.y > viewSize.y * 7 / 8) {
	    vbase.y = -vbase.y;
	    vector.y = - vector.y;
	} else {
	    vector.y += (vector.y == 0) ? 0 : (0 < vector.y) ? -1 : 1;
	}
	break;
	
      case fire1:
	if (step == 0) {
	    new EnemyLaser(head, DVector(-36,-10));
	    new EnemyLaser(head, DVector(-40, 0));
	    new EnemyLaser(head, DVector(-36, 10));
	    new EnemyLaser(tail, DVector(-36,-10));
	    new EnemyLaser(tail, DVector(-40, 0));
	    new EnemyLaser(tail, DVector(-36, 10));
	}
	break;
	
      case fire2:
	switch (step) {
	  case 0:
	    new EnemyLaser(head, DVector(-36,-10));
	    break;
	  case 2:
	    new EnemyLaser(head, DVector(-40, 0));
	    break;
	  case 4:
	    new EnemyLaser(head, DVector(-36, 10));
	    break;
	  case 6:
	    new EnemyLaser(tail, DVector(-36,-10));
	    break;
	  case 8:
	    new EnemyLaser(tail, DVector(-40, 0));
	    break;
	  case 10:
	    new EnemyLaser(tail, DVector(-36, 10));
	    break;
	}
	break;
	
      case fire3:
	switch (step) {
	  case 10:
	    new EnemyLaser(head, DVector(-36,-10));
	    break;
	  case 8:
	    new EnemyLaser(head, DVector(-40, 0));
	    break;
	  case 6:
	    new EnemyLaser(head, DVector(-36, 10));
	    break;
	  case 4:
	    new EnemyLaser(tail, DVector(-36,-10));
	    break;
	  case 2:
	    new EnemyLaser(tail, DVector(-40, 0));
	    break;
	  case 0:
	    new EnemyLaser(tail, DVector(-36, 10));
	    break;
	}
	break;
    }
    locate += vector;    
    step++;
}

/* ##################################################################
   Rock
   ################################################################## */

Rock::Rock(const int s, const DVector & l, const DVector & v) : Enemy(NULL,&rockPxRn[localRand(2)].image(localRand(360)), l, dzero, dzero, DEPTH_BACK), phase(init), vector(v), stepSleep(s) {
}

const Obj::Attr &Rock::getAttr(void) const { return attr; }

void Rock::onFlush(void) {

    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = run;
	    step = 0;
	    continue;
	  case run:
	    break;
	}
	break;
    }
    
    // 볦å
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case run:
	vector += DVector(-0.25,0);
	if (!inView() && locate.x < 0) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;
    step ++;
}

