#ifndef Enemy_H
#define Enemy_H

// header
#include <common.H>

#include <Obj.H>
   
/* ##################################################################
   Enemy1
   ################################################################## */

// Enemy1

class Enemy1 : public Enemy {

  public:
    Enemy1(const int, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;

    void onFlush(void);

protected:
    Part *fin;
    enum { init, sleep, run1, run2, run3 } phase;
    int step;
    DVector vector;
    const int stepSleep;
};
   
// Enemy1a

class Enemy1a : public Enemy {

public:
    Enemy1a(const int, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
protected:
    Part *fin;    
    enum { init, sleep, run1, run2 } phase;
    int step;
    double vdirect;
    DVector vector;
    const int stepSleep;
};

/* ##################################################################
   Enemy2
   ################################################################## */

class Enemy2 : public Enemy {

public:
    Enemy2(const int, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;

    void onFlush(void);
    
protected:
    enum { init, sleep, run1, run2, run3 } phase;
    int step;
    DVector vector;    
    const int stepSleep;
};
   
/* ##################################################################
   Enemy3
   ################################################################## */

class Enemy3 : public Enemy {

public:
    Enemy3(const int, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
protected:
    enum { init, sleep, run1, idle, run2 } phase;
    int step;
    DVector vector;
    const int stepSleep;
};
   
/* ##################################################################
   Enemy4
   ################################################################## */

class Enemy4 : public Enemy {

public:
    Enemy4(const int, const int, const DVector &, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
protected:
    enum { init, sleep, run } phase;
    int step;
    DVector vector;
    const int stepDead;    
    const int stepSleep;
};
   
/* ##################################################################
   EnemyI
   ################################################################## */

class EnemyI : public Enemy {

public:
    EnemyI(const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
protected:
    Part *parts[2][2][2];
    enum { init, cruise, trans1, idle, trans2, move } phase;
    int step;
    DVector vbase;
    DVector vector;
};
   
/* ##################################################################
   EnemyII
   ################################################################## */

class EnemyII : public Enemy {

public:
    EnemyII(const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
private:
    Part *parts[2][3];
    enum { init, cruise, trans1, idle, trans2, move } phase;
    int step;
    DVector vbase;
    DVector vector;
};
   
/* ##################################################################
   EnemyIII
   ################################################################## */

// ENemyIII

class EnemyIII : public Enemy {

public:
    EnemyIII(const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
private:
    Part *head;
    Part *tail;
    enum {
	init, cruise, idle, move,
	mode1_trans1, mode1_trans2,
	mode2_trans1, mode2_trans2,
    } phase;
    int step;
    DVector vbase;
    DVector vector;
};

// ENemyIIIa

class EnemyIIIa : public Enemy {

public:
    EnemyIIIa(const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
private:
    Part *head;
    Part *tail;
    enum {
	init, cruise, idle, move,
	mode1_trans1, mode1_trans2,
	mode2_trans1, mode2_trans2, mode2_trans3,
    } phase;
    int step;
    DVector vbase;
    DVector vector;
};
   
/* ##################################################################
   EnemyIV
   ################################################################## */

class EnemyIV : public Enemy {

public:
    EnemyIV (const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
private:
    Part *head;
    Part *tail;
    Part *pack;
    enum {
	init, cruise, idle, move,
	fire1, fire2, fire3
    } phase;
    int step;
    DVector vbase;
    DVector vector;
};
   
/* ##################################################################
   Rock
   ################################################################## */

class Rock : public Enemy {

public:
    Rock(const int, const DVector & = dzero, const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);

  private:
    enum { init, sleep, run } phase;
    int step;
    DVector vector;
    const int stepSleep;
};

#endif
