// إå
#include <EnemyAttack.H>

/* ##################################################################
   Attributes
   ################################################################## */

const Obj::Attr EnemyLaser::attr(0,DVector(1,1),INT_MAX,INT_MAX,0);
const Obj::Attr EnemyShell::attr(1,DVector(0.8, 0.8),10,INT_MAX,0);
const Obj::Attr EnemyMissile::attr(1,DVector(0.8, 0.8),10,INT_MAX,0);
const Obj::Attr EnemyMissile2::attr(1,DVector(0.8, 0.8),10,INT_MAX,0);
const Obj::Attr EnemyMissile3::attr(1,DVector(0.8, 0.8),10,INT_MAX,0);

/* ##################################################################
   EnemyLaser
   normal
   ################################################################## */

EnemyLaser::EnemyLaser(Part *p, const DVector &l = dzero) : EnemyAttack(p,&laser2Px[0],l, dzero, dzero, DEPTH_ENEMY_ATTACK), phase(init) {}

const Obj::Attr &EnemyLaser::getAttr(void) const { return attr; }

void EnemyLaser::onFlush(void) {

    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = idle;
	    step = 0;
	    continue;
	  case idle:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
      case idle:
	if (step == 11) {
	    isAlive = 0;
	    return;
	}
	image = &laser2Px[step];
	break;
    }
    step ++;
}

/* ##################################################################
   EnemyShell
   ################################################################## */

EnemyShell::EnemyShell(const DVector & l, const double d, const double s) : EnemyAttack(NULL,&enemyShellPxRn, l, dzero, dzero, DEPTH_ENEMY_ATTACK,d), phase(init), speed(s) {}

EnemyShell::EnemyShell(const DVector & l, const DVector &d, const double s) : EnemyAttack(NULL,&enemyShellPxRn, l, dzero, dzero, DEPTH_ENEMY_ATTACK), phase(init), speed(s) {
    setDirect(d,10);
}

const Obj::Attr &EnemyShell::getAttr(void) const { return attr; }

void EnemyShell::onFlush(void) {

    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    vector = DVector(speed,0) % direct;
	    continue;
	  case cruise:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
      case cruise:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;    
    step ++;
}

/* ##################################################################
   EnemyMissile
   normal
   ################################################################## */

EnemyMissile::EnemyMissile(const DVector & l, const double d) : EnemyAttack(NULL,&enemyMissilePxRn[1].image(d),l, dzero, dzero, DEPTH_ENEMY_ATTACK,d), phase(init) {}

EnemyMissile::EnemyMissile(const DVector & l, const DVector &d) : EnemyAttack(NULL,&enemyMissilePxRn[1],l, dzero, dzero, DEPTH_ENEMY_ATTACK), phase(init) {
    setDirect(d,10);
}

const Obj::Attr &EnemyMissile::getAttr(void) const { return attr; }

void EnemyMissile::onFlush(void) {

    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    speed = 1;
	    continue;
	  case cruise:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
      case cruise:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	if (speed < 12) speed += 1;
	vector = DVector(speed,0) % direct;
	break;
    }
    locate += vector;    
    step ++;
}

/* ##################################################################
   EnemyMissile
   homing-missile
   ################################################################## */

EnemyMissile2::EnemyMissile2(Ship *s, const DVector & l, const double di, const DVector & v) : EnemyAttack(NULL,&enemyMissilePxRn[0],l, dzero, dzero, DEPTH_ENEMY_ATTACK,di) , HaveTarget(s), phase(init), vector(v) {
}

const Obj::Attr &EnemyMissile2::getAttr(void) const { return attr; }

void EnemyMissile2::onFlush(void) {

    // å
    updateTarget();
    
    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = detach;
	    step = 0;
	    continue;
	  case detach:
	    if (step < 8) break;
	    phase = homing1;
	    step = 0;
	    dalpha = 10;
	    pixmapRound = &enemyMissilePxRn[1];
	    continue;
	  case homing1:
	    if (step < 18) break;
	    phase = homing2;
	    speed = 4;
	    step = 0;
	    continue;
	  case homing2:
	    if (step < 12) break;
	    phase = off;
	    step = 0;
	    pixmapRound = &enemyMissilePxRn[0];	
	    continue;
	  case off:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
      case detach:
	break;
      case homing1:
	if (objTarget) {
	    if (1 < dalpha) {
		if (adjustDirect(objTarget->locate,dalpha)) {
		    dalpha /= 2;
		}
	    }
	}
	break;
      case homing2:
	if (objTarget) {	
	    adjustDirect(objTarget->locate,10);
	}
	vector = DVector(speed,0) % direct;
	if (speed < 16)	speed += 1;
      case off:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;
    step ++;
}

/* ##################################################################
   EnemyMissile
   first-homing-cruising-missile
   ################################################################## */

EnemyMissile3::EnemyMissile3(Ship *s, const DVector & l, const double di,const DVector & v) : EnemyAttack(NULL, &enemyMissilePxRn[0], l, dzero, dzero, DEPTH_ENEMY_ATTACK, di), HaveTarget(s), phase(init), vector(v) {
}

const Obj::Attr &EnemyMissile3::getAttr(void) const { return attr; }

void EnemyMissile3::onFlush(void) {

    // å
    updateTarget();

    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = detach;
	    step = 0;
	    continue;
	  case detach:
	    if (step < 8) break;
	    phase = homing;
	    step = 0;
	    dalpha = 10;
	    pixmapRound = &enemyMissilePxRn[1];
	    continue;
	  case homing:
	    if (step < 18) break;
	    phase = cruise;
	    speed = 4;
	    step = 0;
	    continue;
	  case cruise:
	    if (step < 12) break;
	    phase = off;
	    step = 0;
	    pixmapRound = &enemyMissilePxRn[0];	
	    continue;
	  case off:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
      case detach:
	break;
      case homing:
	if (objTarget) {
	    if (1 < dalpha) {
		if (adjustDirect(objTarget->locate,dalpha)) {
		    dalpha /= 2;
		}
	    }
	}
	break;
      case cruise:
	vector = DVector(speed,0) % direct;
	if (speed < 16)	speed += 1;
	break;
      case off:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;    
    step ++;
}
