#ifndef EnemyAttack_H
#define EnemyAttack_H

// header
#include <common.H>

#include <Obj.H>
   
/* ##################################################################
   EnemyLaser
   normal
   ################################################################## */

class EnemyLaser : public EnemyAttack {

public:
    EnemyLaser(Part *, const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);

  protected:
    enum { init, idle } phase;	// ֥ȤΥե
    int step;			// եˤ륹ƥå
};
   
/* ##################################################################
   EnemyMissile
   normal
   ################################################################## */

class EnemyMissile : public EnemyAttack {

public:
    EnemyMissile(const DVector &, const double);
    EnemyMissile(const DVector &, const DVector &);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, cruise } phase;	// ֥ȤΥե
    int step;				// եˤ륹ƥå
    DVector vector;
    double speed;
};
   
/* ##################################################################
   EnemyShell
   ################################################################## */

class EnemyShell : public EnemyAttack {

public:
    EnemyShell(const DVector &, const double, const double = 12);
    EnemyShell(const DVector &, const DVector &, const double = 12);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, cruise } phase;	// ֥ȤΥե
    int step;				// եˤ륹ƥå
    DVector vector;
    const double speed;
};

/* ##################################################################
   EnemyMissile
   homing-missile
   ################################################################## */

class EnemyMissile2 : public EnemyAttack, public HaveTarget {

public:
    EnemyMissile2(Ship *,
		  const DVector &,
		  const double = 0,
		  const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, detach, homing1, homing2, off } phase;
    int step;
    DVector vector;
    double speed;
    double dalpha;
};
   
/* ##################################################################
   EnemyMissile
   first-homing-cruising-missile
   ################################################################## */

class EnemyMissile3 : public EnemyAttack, public HaveTarget {

public:
    EnemyMissile3(Ship *,
		  const DVector &,
		  const double = 0,
		  const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, detach, homing, cruise, off } phase;
    int step;
    DVector vector;
    double speed;
    double dalpha;
};

#endif

