// header
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>

#include <XsKey.H>
#include <XsWindow.H>
#include <XsView.H>

#include <Demo.H>
#include <Demo2.H>
#include <Game.H>
#include <AttackEntry.H>
#include <Ship.H>
#include <Misc.H>
#include <Rank.H>

/* ##################################################################
   Game
   ################################################################## */

#define SUBWEAPON_SCORE 1000
// #define NO_OPPONENT
#define STAGE_FIRST 1
#define STAGE_LAST 8

Game *Game::_game = NULL;

Game::Game(void)
: score(0),
  ship(SHIP_NUM),
  rank(Rank::max),
  _score(score),
  scoreTxt("",DVector(viewSize.x,0),DEPTH_FRAME,9,common14Fn, 1),
  startTxt("Game Start",DVector(viewSize/2),DEPTH_FRAME,5,common14Fn,0),
  pauseTxt("Pause",DVector(viewSize/2), DEPTH_FRAME,5,common14Fn,0),
  overTxt("Game Over",DVector(viewSize/2), DEPTH_FRAME,5,common14Fn,0),
  stageNum(STAGE_FIRST),
  stageMax(STAGE_LAST),
  phaseGame(initofGame),
  stepGame(0),
  phaseStage(initofStage),
  stepStage(0),
  stageStream(NULL) {

    // ¸ߤΥå
    if (_game) {
	cerr << "Error !!! : Game state is already existing." << endl;
	exit(1);
    }
    _game = this;

    Rank::load(SCOREFILE);

    // 
    for (int i = 0; i < SHIP_NUM; i ++) {
	DVector l(12 * i, 10 * i);
	shipSp[i].set(&iconPx[0], l, DEPTH_FRAME + i, 1);
    }
}

// ǥȥ饯
Game::~Game(void) {
    
    // ֥Ȥκ
    WriteIter <Part *> wi(Part::partList);
    wi.head();
    while (wi.existNext()) {
	delete wi.elementNext();
	// ˲ȼưŪ˥ꥹȤ롥	
    }

    // åκ
    Message::cleanUp();
    
    // ȥ꡼κ
    delete stageStream;
    stageStream = NULL;

    // ʤ
    _game = NULL;
}

Game *Game::game(void) {
    return _game;
}

// ֤ν
State *Game::func(void) {

    // ݡ
    if ((phaseGame == play || phaseGame == pause) && stepKey.isPressed()) {
	phaseGame = step;
	stepGame = 0;
    }

    // Υե
    for (;;) {
	switch (phaseGame) {

	    // ---------------------------	    	    
	  case initofGame:
	    // ---------------------------
	    if (stepGame == 2) {
		phaseGame = start;
		stepGame = 0;
		continue;
	    }
	    break;
	    
	    // ---------------------------	    	    
	  case start:
	    // ---------------------------	    	    
	    if (stepGame == 0) {
		new ShipViper(DVector(32,viewSize.y/2));
		startTxt.state = 1;
		ship --;
		shipSp[ship].state = 0;
	    }
	    if (2 * fps <= stepGame) {
		startTxt.state = 0;
		Ship::ship()->state = 1;
		phaseGame = play;
		stepGame = 0;
		continue;
	    }
	    Ship::ship()->state = !Ship::ship()->state;
	    doOneStep(1,0);
	    break;
	    
	    // ---------------------------	    	    
	  case hit:
	    // ---------------------------	    	    
	    if (2 * fps <= stepGame) {
		if (0 < ship) {
		    phaseGame = start;
		} else {
		    phaseGame = over;
		}
		stepGame = 0;
		continue;
	    }
	    doOneStep(0,1);
	    break;		
	    
	    // ---------------------------	    	    
	  case over:
	    // ---------------------------
	    if (stepGame == 0) {
		overTxt.state = 1;

		Rank::add(SCOREFILE,
			  (char *)getenv("USER"),
			  score);
	    }
	    if (upKey.isReleased() ||
		downKey.isReleased() ||
		rightKey.isReleased() ||
		leftKey.isReleased() ||
		triggerKey.isReleased() ||
		trigger2Key.isReleased() ||
		30 * fps <= stepGame) {
		return new Demo2;
	    }
	    if (stepGame % fps == 0) overTxt.state = !overTxt.state;
	    doOneStep(0,0);
  	    break;

	    // ---------------------------	    	    
	  case step:
	    // ---------------------------	    	    
	    phaseGame = pause;
	    stepGame = 0;
	    pauseTxt.state = 0;
	    
	    // ---------------------------    
	  case play:
	    // ---------------------------
	    // ߥɲ
	    if (score / SUBWEAPON_SCORE != _score / SUBWEAPON_SCORE) {
		if (Ship::ship()->addSubWeapon()) {
		    Message::add("SubWeapon: Extended");
		}
		_score = score;
	    }
	    // 󥭥®
	    if (0 < rank) {
		if (Rank::get(rank-1).score < score) {
		    Message::add(form("Rank: You Are %dth Order.",rank));
		    rank --;
		}
	    }
	    // ݡ
	    if (pauseKey.isPressed()) {
		if (stateCount % (fps / 2) == 0)
		  pauseTxt.state = !pauseTxt.state;
		phaseGame = pause;
		stepGame = 0;
		break;
	    }
#ifdef NO_OPPONENT
	    doOneStep(1,0);
#else
	    doOneStep(1,1);
#endif
	    if (!Ship::ship()) {
		phaseGame = hit;
		stepGame = 0;
	    }
	    break;
	    
	    // ---------------------------	    	    
	  case pause:
	    // ---------------------------	    	    
	    if (stateCount % (fps / 2) == 0) {
		pauseTxt.state = !pauseTxt.state;
	    }
	    if (pauseKey.isPressed()) {
		pauseTxt.state = 0;	
		phaseGame = play;
		stepGame = 0;
		break;
	    }
	    break;
	}
	break;
    }
    stepGame ++;
    
    // ֤Ϸ³
    return NULL;
}

void Game::doOneStep(int s, int c) {

    // ơǡɤ߹
    if (s) {
	switch (phaseStage) {
	  case initofStage:
	    doStage();
	    break;
	  case frame:
	  case second:
	    stepStage --;
	    if (stepStage <= 0) doStage();
	    break;
	  case enemy:
	    if (Enemy::enemyList.num() <= stepStage) doStage();
	    break;
	  case message:
	    if (Message::message() <= stepStage) doStage();
	    break;
	}
    }
    
    // ֥ȥեå
    Obj::flushAllObj();

    // å
    ShipAttack::checkAttack();
    if (c) {
	EnemyAttack::checkAttack();
	Enemy::checkAttack();
    }

    // ʬեå
    Part::flushAllPart();

    // score
    scoreTxt.text(form("score %08d",score));
}

void Game::doStage(void) {
    
    // ơǡ
    if (!stageStream) {
	file = form(STAGEFILE,stageNum);
	stageStream = new ifstream(file,ios::nocreate|ios::in);
	line = 0;
	if (!stageStream->good()) {
	    cerr
	    << "Error !!! : line " << line << " in " << file
	    << " : Something is wrong with '" << file << "'." << endl;
	    exit(1);
	}
    }
    
    // ɤ߹
    while (stageStream->good()) {
	// ------------------------------------------------
	// ȥ꡼ǤϲԤʤΤǥˡǼ
	// ------------------------------------------------	      
	char l[1024], *p;
	stageStream->getline(l,1024);	// Լ
	line ++;
	p = strtok(l," \t\n\r");		// ڤ
	// ʤн
	if (!p) {
	    break;
	}
	// 
	if (*p == '#') {
	    continue;
	}
	// idle ---------------------------------------------
	if (!strcmp(p,"idle")) {
	    char *s;
	    double n;
	    // μ
	    s = strtok(NULL," \t\n\r");
	    if (!s) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : Missing idle number." << endl;
		exit(1);
	    }
	    if ((n = strtod(s,NULL)) < 0) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : I want number over 0." << endl;
		exit(1);
	    }
	    // ǥեȤη
	    s = strtok(NULL," \t\n\r");
	    if (!s) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : Missing idle type." << endl;
		exit(1);
	    }
	    // Ƚ
	    if ((!strcmp(s,"frame") || !strcmp(s,"second")) && n == 0) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : I want number over 0." << endl;
		exit(1);
	    }
	    if (!strcmp(s,"frame")) {
		phaseStage = frame;
		stepStage = int(n);
	    } else if (!strcmp(s,"second")) {
		phaseStage = second;		    
		stepStage = int(n * fps);
	    } else if (!strcmp(s,"enemy")) {
		phaseStage = enemy;
		stepStage = int(n);
	    } else if (!strcmp(s,"message")) {
		phaseStage = message;
		stepStage = int(n);
	    } else {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : Unexpected idle type." << endl;
		exit(1);
	    }
	    // ;ʬʤΤĤƤ뤫
	    s = strtok(NULL," \t\n\r");		
	    if (s && *s != '#') {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : Too much argument detected." << endl;
		exit(1);
	    }
	    break;
	}
	// Message ------------------------------------------
	if (!strcmp(p,"message")) {
	    char *s;
	    s = strtok(NULL,"\n\r");
	    Message::add(s);
	    continue;
	}
	// attack ---------------------------------------------
	if (!strcmp(p,"attack")) {
	    char *e;
	    int c = 0;
	    AttackParam v[16];
	    // ȥ̾μ		
	    e = p = strtok(NULL," \t\n\r");
	    // ԡ		
	    if (!p) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : Entry name is missing." << endl;
		exit(1);
	    }
	    // ɤ߹
	    p = strtok(NULL," \t\n\r");
	    while (p && *p != '#') {
		char *h;
		v[c].value = strtod(p,&h);
		v[c].string = p;
		// ҡ
		switch (*h) {
		case 'x' :
		    v[c].value *= viewSize.x;
		    break;
		case 'y' :
		    v[c].value *= viewSize.y;
		    break;
		case 'p' :
		    if (0 <= v[c].value) v[c].value += viewSize.x;
		    break;
		case 'q' :
		    if (0 <= v[c].value) v[c].value += viewSize.y;
		    break;
		case 's' :
		    v[c].value *= fps;
		    break;
		}
		p = strtok(NULL," \t\n\r");
		c ++;
	    }
	    // ȥ긡
	    struct AttackEntry *ae = attackEntry;
	    while (ae->name && strcasecmp(ae->name,e)) {
		ae ++;
	    }
	    if (!ae->name) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : '" << e << "' is unexpected attack entry." << endl;
		exit(1);
	    }
	    if (c < ae->min || ae->max < c) {
		cerr
		<< "Error !!! : line " << line << " in " << file
		<< " : '" << e << "' has " << c << " args ,"
		<< " expected from " << ae->min
		<< " to " << ae->max << "." << endl;
		exit(1);
	    }
	    ae->func(c,v);
	    continue;
	}
	// ǽʥޥ
	cerr
	<< "Error !!! : line " << line << " in " << file
	<< " : '" << p << "' is unexpected data command." << endl;
	exit(1);	    
    }

    // ơǡλ
    if (!stageStream->good()) {
	delete stageStream;
	stageStream = NULL;
	if (stageNum == stageMax) {
	    stageNum = STAGE_FIRST;
	} else {
	    stageNum ++;
	}
    }
}
