// header
#include <Misc.H>
   
/* ##################################################################
   Light Ball
   ################################################################## */

Light::Light(const int s, const DVector &l, const int c) : Misc(NULL,(XsPixmap *)NULL, l, dzero, dzero, DEPTH_FRONT,0), phase(init), stepSleep(s), stepLight(c) {

    // count ͭɤĴ٤롥
    if (stepLight < 0 || 9 <= stepLight) {
	cerr << "Error !!! : Invalid count in Light::Light()." << endl;
	exit(1);
    }

    // ᡼
    image = &lightPx[stepLight];
}

void Light::onFlush(void) {

    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = sleep;
	    step = 0;
	    state = 0;	    
	    continue;
	  case sleep:
	    if (step < stepSleep) break;
	    phase = idle;
	    step = stepLight;
	    state = 1;
	    continue;
	  case idle:
	    if (step < 9) break;
	    phase = off;
	    continue;
	  case off:
	    break;
	}
	break;
    }
    
    // 
    switch (phase) {
      case init:
	break;
      case sleep:
	break;
      case idle:
	image = &lightPx[step];
	break;
      case off:
	isAlive = 0;
	break;
    }
    step ++;
}
   
/* ##################################################################
   Message
   ################################################################## */

Message *Message::recentOne;
List <String> Message::stringList;

Message::Message(const String &s) : Misc(NULL,&messageTxt, DVector(viewSize.x/2,viewSize.y),dzero,dzero,DEPTH_FRAME), messageTxt(s, 8, common14Fn), phase(init), step(0) {
}

void Message::add(const String &s) {
    if (recentOne) {
	stringList.add(s);
    } else {
	recentOne = new Message(s);
    }
}

void Message::cleanUp(void) {
    WriteIter <String> wi(stringList);
    while (wi.existNext()) {
	wi.deleteNext();
    }
}

int Message::message(void) {
    return ((recentOne) ? 1 : 0) + stringList.num();
}

void Message::onFlush(void) {

    // 
    for (;;) {
	switch (phase) {
	  case init:
	    phase = up;
	    step = 0;
	    continue;
	  case up:
	    if (step * 2 < fps) break;
	    phase = idle;
	    step = 0;
	    continue;	    
	  case idle:
	    if (step < fps * 4 / 3) break;
	    phase = down;
	    step = 0;
	    state = 1;
	    
	    recentOne = NULL;

	    if (stringList.num()) {
		WriteIter <String> wi(stringList);
		recentOne = new Message(wi.elementNext());
		wi.deleteNext();
	    }
	      
	    continue;	    
	  case down:
	    if (step * 2 < fps) break;
	    phase = off;
	    step = 0;
	    continue;
	  case off:
	    break;
	}
	break;
    }

    // 
    switch (phase) {
      case init:
	break;
      case up:
	locate.y -= 2;
	break;
      case idle:
	break;
      case down:
	locate.y -= 2;
	break;
      case off:
	isAlive = 0;
	break;
    }
    step ++;
}
