#ifndef Misc_H
#define Misc_H

// header
#include <common.H>
#include <Obj.H>
#include <Sprite.H>
   
/* ##################################################################
   Light Ball
   ################################################################## */

class Light : public Misc {

public:
    Light(const int = 0, const DVector & = dzero, const int = 0);
    
    void onFlush(void);

private:
    enum { init, sleep, idle, off } phase;
    int step;
    const int stepSleep;
    const int stepLight;
};
   
/* ##################################################################
   Message
   ################################################################## */

class Message : public Misc {
    
    Message(const String &);
    
  public:

    void onFlush(void);
    
    static void add(const String &);
    static void cleanUp(void);
    static int message(void);
    
    static Message *recentOne;
    static List <String> stringList;
    
  private:
			   
    const XsText messageTxt;
    enum { init, up, idle, down, off } phase;
    int step;
};

#endif
