// header
#include <stdlib.h>
#include <string.h>
#include <sys/file.h>

#include <fstream.h>
#include <iostream.h>

#include <Rank.H>

/* ##################################################
   Rank
   ################################################## */

// #define NEED_LOCK

const int Rank::max = 10;
Rank Rank::rank[Rank::max + 1];

Rank::Rank(const String &n, const int s) : name(n), score(s) {}

Rank::Rank(const Rank &r) : name(r.name), score(r.score) {}

const Rank &Rank::operator = (const Rank &r) {
    
    name = r.name;
    score = r.score;
    
    return *this;
}

const Rank &Rank::get(const int r) {
    if (0 <= r && r < max) {
	return rank[r];
    } else {
	cerr << "Error !!! : Over the range in Rank::get()" << endl;
	exit(1);
    }
}

void Rank::load(const String &f) {
    FILE *fp = fopen(f,"r");
    if (fp == NULL) {
	cerr << "Error !!! : Wrong with opening score file." << endl;
	exit(1);
    }
#ifdef NEED_LOCK    
    flock(int(fp), LOCK_SH);
#endif    
    _load(fp);
#ifdef NEED_LOCK    
    flock(int(fp), LOCK_UN);
#endif    
    fclose(fp);
}

void Rank::add(const String &f, const String &n, const int s) {
    FILE *fp = fopen(f,"r+");
    if (fp == NULL) {
	cerr << "Error !!! : Wrong with opening score file." << endl;
	exit(1);
    }
#ifdef NEED_LOCK    
    flock(int(fp), LOCK_EX);
#endif    
    _load(fp);
    _add(n,s);
    _save(fp);
#ifdef NEED_LOCK    
    flock(int(fp), LOCK_UN);
#endif    
    fclose(fp);
}

void Rank::_load(FILE *fp) {

    for (int i = 0; i < max; i ++) {
	char *n, *s, l[1024];
	if (fgets(l,sizeof l,fp) == NULL) {
	    cerr << "Error !!! : No enough lines in score file." << endl;
	    exit(1);
	}
	if ((n = strtok(l," \t\n\r")) == NULL) break;
	if ((s = strtok(NULL," \t\n\r")) == NULL) {
	    cerr << "Error !!! : Missing score in score file." << endl;
	    exit(1);
	}
	_add(n,atoi(s));
    }    
}

void Rank::_save(FILE *fp) {

    rewind(fp);
    
    for (int i = 0; i < max; i ++) {
	Rank &r = rank[i];
	fprintf(fp, "%-15s%10d\n", r.name.chars(), r.score);
    }
}

void Rank::_add(const String &n, const int s) {

    // ͤʤȴ
    if (s < rank[max-1].score) return;
    
    // Ʊ̾뤫ɤĴ٤롥
    for (int i = 0; i < max ; i ++) {
	// Ĥ
	if (rank[i].name == n) {
	    // ؤɬפʤ
	    if (s <= rank[i].score) {
		return;
	    }
	    // ޤǤΤä
	    for (int j = i; j < max; j ++) {
		rank[j] = rank[j + 1];
	    }
	}
    }

    // ɲä롥
    for (int i = max - 1; 0 <= i; -- i) {
	if (s <= rank[i].score) {
	    rank[i+1] = Rank(n,s);
	    return;
	}
	rank[i+1] = rank[i];
    }
    rank[0] = Rank(n,s);
}
