// header
#include <ShipAttack.H>
#include <Ship.H>

/* ##################################################################
   Attributes
   ################################################################## */

const Obj::Attr ShipViper::attr(1, DVector(0.6, 0.6), 10, 10, 0);
   
/* ##################################################################
   Ship-Viper
   ################################################################## */

#define MISSILE_INIT_NUM 1

ShipViper::ShipViper(const DVector & l) : Ship(NULL,&shipPx,l,dzero,dzero,DEPTH_SHIP, 0, MISSILE_INIT_NUM) {

    // ߥΥ
    for (int i = 0; i < MISSILE_FULL_NUM; i ++) {
	DVector l(32 + 12 * i, 10 * i);
	int j = (i < MISSILE_FULL_NUM - 1) ? 1 : 2;
	int s = (i < _subWeapon) ? 1 : 0;
	missileSp[i].set(&iconPx[j], l, DEPTH_FRAME + i, s);
    }
}

const Obj::Attr &ShipViper::getAttr(void) const { return attr; }

int ShipViper::useMainWeapon(void) {
    
    if (childList.num()) {
	
	return 0;
	
    } else {
	
	new ShipLaser(this, DVector(28,0));
	
	return 1;
    }
}

int ShipViper::useSubWeapon(void) {

    if (_subWeapon == 0) {
	
	return 0;
	
    } else {
	
	// ͶƳƤȯ
	const int max = 10;
	if (Enemy::enemyList.num()) {
	    // ɸŪ¸ߤ
	    ReadIter <Enemy *> ei(Enemy::enemyList);
	    int n = 0;
	    int l = 0;
	    while (n < max || l < 1) {
		if (ei.existNext()) {
		    int d = -120 + 180 * localRand(2) + localRand(60);
		    new ShipMissile2(ei.elementNext(),
				     locate, d, DVector(2,0) % d);
		    n ++;
		    ei.next();
		} else {
		    l ++;
		    ei.head();
		}
	    }
	} else {
	    // ɸŪ¸ߤʤ	    
	    for (int i = 0;i < max;i ++) {
		new ShipMissile2(NULL,
				 locate, localRand(240) - 120);
	    }
	}
	_subWeapon --;
	missileSp[_subWeapon].state = 0;

	return 1;
    }
}

int ShipViper::addSubWeapon(void) {
    if (MISSILE_FULL_NUM <= _subWeapon) {
	return 0;
    } else {
	missileSp[_subWeapon].state = 1;
	_subWeapon ++;
	return 1;
    }
}

void ShipViper::onFlush(void) {

    // ư
    if (upKey.is() && image->size().y / 2 < locate.y) {
	locate.y -= 8;
    }
    if (downKey.is() && locate.y < view.size().y - image->size().y / 2) {
	locate.y += 8;
    }
    if (leftKey.is() && image->size().x / 2 < locate.x ) {
	locate.x -= 8;
    }
    if (rightKey.is() && locate.x < view.size().x - image->size().x / 2) {
	locate.x += 8;
    }

    //     
    if (trigger2Key.is()) {
	useMainWeapon();
    }
    if (triggerKey.isPressed()) {
	useSubWeapon();
    }
}
