// header
#include <ShipAttack.H>

/* ##################################################################
   Attributes
   ################################################################## */

const Obj::Attr ShipLaser::attr(0,DVector(1, 1),100,INT_MAX,0);
const Obj::Attr ShipMissile::attr(1,DVector(0.8, 0.8),500,INT_MAX,0);
const Obj::Attr ShipMissile2::attr(1,DVector(0.8, 0.8),500,INT_MAX,0);
const Obj::Attr ShipMissile3::attr(1,DVector(0.8, 0.8),500,INT_MAX,0);

/* ##################################################################
   ShipLaser
   normal
   ################################################################## */

ShipLaser::ShipLaser(Part *p,const DVector &l) : ShipAttack(p,&laser0Px[0],l,dzero,dzero,DEPTH_SHIP_ATTACK), phase(init) {}

const Obj::Attr &ShipLaser::getAttr(void) const { return attr; }

void ShipLaser::onFlush(void) {

    // ե֤
    switch (phase) {
    case init:
	phase = idle;
	step = 0;
	break;
      case idle:
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
    case idle:
	if (step == 11) {
	    isAlive = 0;
	    return;
	}
	image = &laser0Px[step];
	break;
    }
    step ++;
}

/* ##################################################################
   ShipMissile
   normal
   ################################################################## */

ShipMissile::ShipMissile(const DVector &l, const double d) : ShipAttack(NULL,&shipMissilePxRn[1], l, dzero, dzero, DEPTH_SHIP_ATTACK, d), phase(init) {}

ShipMissile::ShipMissile(const DVector &l, const DVector &d) : ShipAttack(NULL, &shipMissilePxRn[1], l, dzero, dzero, DEPTH_SHIP_ATTACK), phase(init) {
    setDirect(d, 10);
}

const Obj::Attr &ShipMissile::getAttr(void) const { return attr; }

void ShipMissile::onFlush(void) {

    // ե֤
    for (;;) {
	switch (phase) {
	  case init:
	    phase = cruise;
	    step = 0;
	    continue;
	  case cruise:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
    case cruise:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += DVector(16,0);
    step ++;
}

/* ##################################################################
   ShipMissile
   homing-missile
   ################################################################## */

ShipMissile2::ShipMissile2(Enemy *e, const DVector &l, const double di, const DVector & v) : ShipAttack(NULL, &shipMissilePxRn[0], l, dzero, dzero, DEPTH_SHIP_ATTACK, di), phase(init), HaveTarget(e), vector(v) {
}

const Obj::Attr &ShipMissile2::getAttr(void) const { return attr; }

void ShipMissile2::onFlush(void) {

    // åȤι
    updateTarget();
    
    // ե֤
    for (;;) {
	switch (phase) {
	case init:
	    phase = detach;
	    step = 0;
	    continue;
	case detach:
	    if (step < 0) break;
	    phase = homing1;
	    step = 0;
	    dalpha = 10;
	    pixmapRound = &shipMissilePxRn[1];
	    continue;
	case homing1:
	    if (step < 0) break;
	    phase = homing2;
	    step = 0;
	    speed = 4;	    
	    continue;
	case homing2:
	    if (step < 2 * fps) break;
	    phase = off;
	    step = 0;
	    pixmapRound = &shipMissilePxRn[0];
	    continue;
	  case off:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
    case detach:
	break;
    case homing1:	
	if (objTarget && 1 < dalpha) {
	    if (adjustDirect(objTarget->locate,dalpha)) {
		dalpha /= 2;
	    }
	}
	break;
    case homing2:
	if (objTarget) {
	    adjustDirect(objTarget->locate,10);
	} else if (Enemy::enemyList.num()){
	    ReadIter <Enemy *> ri(Enemy::enemyList);
	    for (int i = localRand(Enemy::enemyList.num());
		 0 < i; ri.next(), i --) {}
	    setTarget(ri.elementNext());
	}
	vector = DVector(speed,0) % direct;
	if (speed < 16) speed += 1;
    case off:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;    
    step ++;    
}

/* ##################################################################
   ShipMissile
   first-homing-cruising-missile
   ################################################################## */

ShipMissile3::ShipMissile3(Enemy *e, const DVector &l, const double di,const DVector &v) : ShipAttack(NULL, &shipMissilePxRn[0], l, dzero, dzero, DEPTH_ENEMY_ATTACK, di) , phase(init), HaveTarget(e), vector(v) {
}

const Obj::Attr &ShipMissile3::getAttr(void) const { return attr; }

void ShipMissile3::onFlush(void) {

    // åȤι
    updateTarget();

    // ե֤
    for (;;) {
	switch (phase) {
	case init:
	    phase = detach;
	    step = 0;
	    continue;
	case detach:
	    if (step < 8) break;
	    phase = homing;
	    step = 0;
	    dalpha = 10;
	    pixmapRound = &shipMissilePxRn[1];
	    continue;
	case homing:
	    if (step < 18) break;
	    phase = cruise;
	    speed = 4;
	    step = 0;
	    continue;
	case cruise:
	    if (step < 12) break;
	    phase = off;
	    step = 0;
	    pixmapRound = &shipMissilePxRn[0];	
	    continue;
	  case off:
	    break;
	}
	break;
    }
    
    // եν
    switch (phase) {
      case init:
	break;
    case detach:
	break;
    case homing:
	if (objTarget && 1 < dalpha) {
	    if (adjustDirect(objTarget->locate,dalpha)) {
		dalpha /= 2;
	    }
	}
	break;
    case cruise:
	vector = DVector(speed,0) % direct;
	if (speed < 16)	speed += 1;
	break;
    case off:
	if (!inView()) {
	    isAlive = 0;
	    return;
	}
	break;
    }
    locate += vector;    
    step ++;
}

