#ifndef SHIPATTACK_H
#define SHIPATTACK_H

// header
#include <common.H>

#include <Obj.H>
   
/* ##################################################################
   ShipLaser
   ################################################################## */

class ShipLaser : public ShipAttack {

  public:
    ShipLaser(Part *, const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, idle } phase;
    int step;
};
   
/* ##################################################################
   ShipMissile
   normal
   ################################################################## */

class ShipMissile : public ShipAttack {

public:
    ShipMissile(const DVector &, const double = 0);
    ShipMissile(const DVector &, const DVector &);
    
    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, cruise } phase;
    int step;
};

/* ##################################################################
   ShipMissile
   homing-missile
   ################################################################## */

class ShipMissile2 : public ShipAttack, public HaveTarget {

public:
    ShipMissile2(Enemy *,
		 const DVector &,
		 const double = 0,
		 const DVector & = dzero);
    
    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, detach, homing1, homing2 , off } phase;
    int step;
    DVector vector;
    double speed;
    double dalpha;
};
   
/* ##################################################################
   ShipMissile
   first-homing-cruising-missile
   ################################################################## */

class ShipMissile3 : public ShipAttack, public HaveTarget {

public:
    ShipMissile3(Enemy *,
		 const DVector &,
		 const double = 0,
		 const DVector & = dzero);

    static const Obj::Attr attr;
    const Obj::Attr &getAttr(void) const;
    
    void onFlush(void);
    
  protected:
    enum { init, detach, homing, cruise, off } phase;
    int step;
    DVector vector;
    double speed;
    double dalpha;
};

#endif
