#ifndef Sprite_H
#define Sprite_H

// header
#include <XsSprite.H>
#include <XsText.H>

#include <common.H>

/* ########################################################
   Sprite
   ######################################################## */

class Sprite : public XsSprite {
    
  public:
    Sprite(const XsImage * = &nullImage,
	   const DVector & = dzero,
	   const double = DEPTH_FRAME,
	   const int = 0);
    void set(const XsImage * = &nullImage,
	     const DVector & = dzero,
	     const double = DEPTH_FRAME,	     
	     const int = 0);
};

/* ########################################################
   Text
   ######################################################## */

class Text : public XsText, public XsSprite {
    
public:
    Text(const String & = "NoText",
	 const DVector & = dzero,
	 const double = DEPTH_FRAME,	 
	 int = 5,
	 const XsFont & = XsFont::defaultFont,
	 int = 0);
    void set(const String & = "NoText",
	     const DVector & = dzero,
	     const double = DEPTH_FRAME,
	     int = 5,
	     const XsFont & = XsFont::defaultFont,
	     int = 0);
};

#endif
