/* ####################################################################
   ᥤ
   #################################################################### */

// header
#include <time.h>
#include <signal.h>
#include <sys/time.h>
#include <unistd.h>
#include <iomanip.h>

#include <common.H>
#include <Main.H>
#include <Obj.H>

// #define SHOW_STATE
#define USE_SIGALRM
// #define FILL_UNCHANGE

#ifdef SHOW_STATE
// ơɽ
static void showStatus(void) {

    static time_t lt = time(NULL);
    static time_t ct = lt;
    static int nm = 0;
    static int nt = 0;
    static int na = 0;
    static int ms = 0;
    static int hz = 0;
    nt += view.numChangedTiles();
    na += view.numChangedAreas();
    ms += view.mapSize().x * view.mapSize().y;
    hz ++;
    if (!nm) {
	cout << "fps|";
	cout << "area/total ";
	cout << "rate|";
	cout << "objs|";
        cout << "parts(child)|";
	cout << "spr|";	
	cout << endl;
        cout << "---+";
        cout << "-----";
        cout << "----------+";  
        cout << "----+";
        cout << "------------+";
        cout << "---+";	
	cout << endl;
    }
    if (lt != ct) {
        int p = int(double(nt)/ms*100);
        cout << setw(3) << hz << "|";
        cout << setw(4) << nt << "/" << setw(5) << ms << " ";
        cout << setw(3) << p << "%|";
        cout << setw(4) << Obj::objList.num() << "|";
        cout << setw(5) << Part::partList.num() << "(";
	cout << setw(5) << Part::numofPart << ")|";
	cout << setw(3) << view.setSprite.num() << "|";	
        cout << endl;
        nt = na = ms = 0;
        lt = ct;
        hz = 0;
    }
    ct = time(NULL);
    nm ++;
}
#endif

// ʥϥɥ
#ifdef USE_SIGALRM
static struct itimerval value, ovalue;
static int isDeliveredSIGALRM;
static void handlerofSIGALRM(int) {
    
    signal(SIGALRM, handlerofSIGALRM);
    isDeliveredSIGALRM = 1;
}
static void initSIGALRM(void) {
    signal(SIGALRM,handlerofSIGALRM);
    value.it_interval.tv_sec = 0;
    value.it_interval.tv_usec = 1000 * 1000 / fps;
    value.it_value.tv_sec = 0;
    value.it_value.tv_usec = 1000 * 1000 / fps;
    setitimer(ITIMER_REAL, &value, &ovalue);
}
static void waitSIGALRM(void) {
    if (isDeliveredSIGALRM == 0) pause();
    isDeliveredSIGALRM = 0;
}
#endif

// ᥤ
main() {
    
    // ֥ȤȤƤΥᥤμ¹
    Main m;

#ifdef FILL_UNCHANGE
    // debugging
    view.isFillUnchangedTiles = 1;
#endif

    // ɽ
    view.refresh();
    
#ifdef USE_SIGALRM
    // ޤν
    initSIGALRM();
#endif
    // 'q'ޤ
    while (!quitKey.isPressed()) {

	// Ե
#ifdef USE_SIGALRM
	waitSIGALRM();
#else
	usleep(1000 * 1000 / fps);
#endif
#ifdef SHOW_STATE      
	showStatus();
#endif	
	m.state();
    }
}
