#ifndef List_H
#define List_H

// إå
#include <stream.h>

/* ##############################################################
   ꥹȥ饹 version 3.1

   ǽ
   ꥹ
   եꥹȥ饹
   祯饹
   Ϣ

   
   ɬפʵǽ·äƤ롥ListNodeIteratorμ̤ʬǤ롥NodeListHeadTail򹹿IteratorNum򹹿Ƥ롥ϡNodeElementƤʪƤʪζڤ˻ѤƤ뤫Ǥ롥

   եꥹ
   SortedListϡΥдؿadd()ˤɲä줿ǤΤߡȤ롥ΤᡤWritableIterǤʤ褦ˤʤäƤ롥㥹ȤݤˤϤθ¤ǤϤʤºݤǤɲäˤϤˡѤƤ롥ʤߤˡǤӲǽǤʤФʤʤΤϤޤǤʤ

   Ӵؿ꥽եꥹ
   եꥹȤӴؿꤹ褦ˤΡ
   
   Writable/Readable Iter
   ReadableWritableIterѰդϡSortedListΤǤ롥

   Ϣ
   Ϣ򥵥ݡȤΥˤϥǥեȤͤ˽Ƥ롥ͤϥ󥹥ȥ饯ǻꤹ롥ǥեȤǤ0Ǥ롥
   ############################################################## */

//
// node
//
template <class Tmp> class Node {

    // 
public:
    Node(List<Tmp> &l,Node *p,Node *n,Tmp c)
    : list(l),prev(p),next(n),element(new Tmp(c)) {
    }
    Node(List<Tmp> &l,Node *p,Node *n)
    : list(l),prev(p),next(n),element(NULL) {
    }
    ~Node(void) {
	delete element;
	element = NULL;
    }
    
    void insertNext(Tmp c) {
	if (next != NULL) {
	    Node *tmp = new Node<Tmp>(list,this,next,c);
	    next->prev = tmp;
	    next = tmp;
	} else {
	    Node *tmp = new Node<Tmp>(list,this,next,c);
	    next = tmp;
	    list.tail = tmp;
	}
    }
    void insertNext(void) {
	if (next != NULL) {
	    Node *tmp = new Node<Tmp>(list,this,next);
	    next->prev = tmp;
	    next = tmp;
	} else {
	    Node *tmp = new Node<Tmp>(list,this,next);
	    next = tmp;
	    list.tail = tmp;
	}
    }
    int deleteNext(void) {
	if (next != NULL) {
	    if (next->next != NULL) {
		Node *tmp = next;
		next->next->prev = this;
		next = next->next;
		delete tmp;
	    } else {
		Node *tmp = next;
		next = next->next;
		list.tail = this;
		delete tmp;
	    }
	    return 1;
	} else {
	    return 0;
	}
    }

    void insertPrev(Tmp c) {
	if (prev != NULL) {
	    Node *tmp = new Node<Tmp>(list,prev,this,c);
	    prev->next = tmp;
	    prev = tmp;
	} else {
	    Node *tmp = new Node<Tmp>(list,prev,this,c);
	    prev = tmp;
	    list.head = tmp;
	}
    }
    void insertPrev(void) {
	if (prev != NULL) {
	    Node *tmp = new Node<Tmp>(list,prev,this);
	    prev->next = tmp;
	    prev = tmp;
	} else {
	    Node *tmp = new Node<Tmp>(list,prev,this);
	    prev = tmp;
	    list.head = tmp;
	}
    }
    int deletePrev(void) {
	if (prev != NULL) {
	    if (prev->prev != NULL) {
		Node *tmp = prev;
		prev->prev->next = this;
		prev = prev->prev;
		delete tmp;
	    } else {
		Node *tmp = prev;
		prev = prev->prev;
		list.head = this;
		delete tmp;
	    }
	    return 1;
	} else {
	    return 0;
	}
    }
    
    // 
public:
    List<Tmp> &list;
    Node *prev;
    Node *next;
    Tmp *element;
};

//
// base iterator
//
template <class Tmp> class Iter {

    // 
public:
    Iter(const List<Tmp> &l) : list(l),node(l.head) {}
    
    // 
private:
    const List<Tmp> &list;
protected:
    Node<Tmp> *node;

    // Ū
public:
    void head(void) { node = list.head; }
    void tail(void) { node = list.tail; }
    
    int existPrev(void) const {
	if (node->prev != NULL && node->prev->prev != NULL) {
	    return 1;
	} else {
	    return 0;
	}
    }
    int existNext(void) const {
	if (node->next != NULL && node->next->next != NULL) {
	    return 1;
	} else {
	    return 0;
	}
    }
    
    int next(void) {
	if (node->next != NULL && node->next->next != NULL) {
	    node = node->next->next;
	    return 1;
	} else {
	    return 0;
	}
    }
    int prev(void) {
	if (node->prev != NULL && node->prev->prev != NULL) {
	    node = node->prev->prev;
	    return 1;
	} else {
	    return 0;
	}
    }
};

//
// readable iterator
//
template <class Tmp> class ReadIter : public Iter<Tmp> {

    // 
public:
    ReadIter(const List<Tmp> &l) : Iter<Tmp>(l) {}
    
    // Ū
public:
    
    const Tmp &elementNext(void) const {
	return *node->next->element;
    }
    const Tmp &elementPrev(void) const {
	return *node->prev->element;
    }
};

//
// writable iterator
//
template <class Tmp> class WriteIter : public Iter<Tmp> {

    // 
private:
    WriteIter(SortedList<Tmp> &l) : Iter<Tmp>(l),list(l) {}
public:
    WriteIter(List<Tmp> &l) : Iter<Tmp>(l),list(l) {}
    
    // 
protected:
    List<Tmp> &list;

    // ưŪ
public:
    void insertNext(Tmp c) {
	node->insertNext();
	node->insertNext(c);
	list._num ++;
    }
    void deleteNext(void) {
	node->deleteNext();
	node->deleteNext();
	if (list._num) {
	    list._num --;
	}
    }
    Tmp &elementNext(void) const {
	return *node->next->element;
    }
    
    void insertPrev(Tmp c) {
	node->insertPrev();
	node->insertPrev(c);
	list._num ++;
    }
    void deletePrev(void) {
	node->deletePrev();
	node->deletePrev();
	if (list._num) {
	    list._num --;
	}
    }
    Tmp &elementPrev(void) const {
	return *node->prev->element;
    }
};

//
// list
//
template <class Tmp> class List {

friend class Node<Tmp>;
friend class Iter<Tmp>;
friend class ReadIter<Tmp>;
friend class WriteIter<Tmp>;

    // 
public:
    List(void)
    : head(new Node<Tmp>(*this,NULL,NULL)),tail(head),_num(0) {
    }
    virtual ~List(void) {
	WriteIter<Tmp> i(*this);
	while (i.existNext()) {
	    i.deleteNext();
	}
	delete head;
	head = NULL;
    }

    int num(void) const {
	return _num;
    }

    int exist(Tmp c) {
	ReadIter<Tmp> i(*this);
	i.head();
	while (i.existNext()) {
	    if (i.elementNext() == c) {
		return 1;
	    }
	    i.next();
	}
	return 0;
    }
    
    virtual void add(Tmp c) {
	WriteIter<Tmp> i(*this);
	i.tail();
	i.insertPrev(c);
    }

    int remove(Tmp c) {
	WriteIter<Tmp> i(*this);
	while (i.existNext()) {
	    if (i.elementNext() == c) {
		i.deleteNext();
		return 1;
	    }
	    i.next();
	}
	return 0;
    }
    
    // 
private:
    Node<Tmp> *head;
    Node<Tmp> *tail;
    int _num;
};

//
// sorted list
//
template <class Tmp> class SortedList : public List<Tmp> {

    // 
public:
    virtual void add(Tmp c) {
	WriteIter<Tmp> i(*(List<Tmp>*)this);
	i.head();
	while (i.existNext()) {
	    if (c < i.elementNext()) {
		break;
	    }
	    i.next();
	}
	i.insertNext(c);
    }
};

// set
template <class Tmp> class Set : public SortedList<Tmp> {

    // 
public:
    virtual void add(Tmp c) {
	if (exist(c) == 0) {
	    SortedList<Tmp>::add(c);	
	}
    }
};

// association list
template <class Key,class Map> class AssocList {

    // õ
public:
    AssocList(const Map &m = 0) : defaultValue(m) {}
    
    // 
private:
    const Map defaultValue;
    Map dummy;
    List<Key> _key;
    List<Map> _map;
public:
    const List<Key> &key(void) const { return _key; }
    const List<Map> &map(void) const { return _map; }
    void remove(Key k) {
	WriteIter<Key> ik(_key);
	WriteIter<Map> im(_map);
	while (ik.existNext()) {
	    if (ik.elementNext() == k) {
		ik.deleteNext();
		im.deleteNext();
		return;
	    }
	    ik.next();
	    im.next();
	}
    }
    
    // 
public:
    int num(void) const {
	return _key.num();
    }
    Map &operator[](const Key k) {
	if (_key.exist(k) == 0) {
	    _key.add(k);
	    _map.add(defaultValue);
	}
	ReadIter<Key> ik(_key);
	WriteIter<Map> im(_map);
	while (ik.existNext()) {
	    if (ik.elementNext() == k) {
		return im.elementNext();
	    }
	    ik.next();
	    im.next();
	}
	return dummy;
    }
};

#endif
