//
// XsBase.C
//

// إå
#include <XsBase.H>

// ѿ
Display * XsBase::display;
XEvent XsBase::event;
Window XsBase::root;
int XsBase::screen;
int XsBase::depth;
int XsBase::displayWidth;
int XsBase::displayHeight;
unsigned long XsBase::black;
unsigned long XsBase::white;
Visual *XsBase::visual;
Colormap XsBase::colorMap;
GC XsBase::gc;
GC XsBase::gcCopy;
GC XsBase::gcStippled;
GC XsBase::gcAnd;
GC XsBase::gcOr;
GC XsBase::gcWhite;
GC XsBase::gcBlack;
GC XsBase::gc1;
GC XsBase::gc1Copy;
GC XsBase::gc1Stippled;
GC XsBase::gc1And;
GC XsBase::gc1Or;
GC XsBase::gc1White;
GC XsBase::gc1Black;

/* ###################################################################
   class XsBase
   쥯饹
   ################################################################### */

// 󥹥ȥ饯
XsBase::XsBase(void) {}

// ǥȥ饯
XsBase::~XsBase(void) {}

// ŪФν
void XsBase::construct(void) {
    
    // 
    if ((display = XOpenDisplay(NULL)) == NULL) {
	cerr << "ERROR !!! : cannot connect to X server" << endl;
	exit(1);
    }

    // ǥեͤμ
    root = DefaultRootWindow(display);
    screen = DefaultScreen(display);

    displayWidth = DisplayWidth(display,screen);
    displayHeight = DisplayHeight(display,screen);
    
    depth = DefaultDepth(display,screen);
    
    black = BlackPixel(display,screen);
    white = WhitePixel(display,screen);
    
    visual = DefaultVisual(display,screen);
    colorMap = DefaultColormap(display,screen);
    
    // graphic context
    gc = XCreateGC(display,root,0,NULL);
    XSetGraphicsExposures(display,gc,False);
    
    gcCopy = XCreateGC(display,root,0,NULL);
    XSetGraphicsExposures(display,gcCopy,False);
    XSetFillStyle(display,gcCopy,FillOpaqueStippled);
    
    gcStippled = XCreateGC(display,root,0,NULL);
    XSetGraphicsExposures(display,gcStippled,False);
    XSetFillStyle(display,gcStippled,FillStippled);
    
    gcAnd = XCreateGC(display,root,0,NULL);
    XSetFunction(display,gcAnd,GXand);
    XSetForeground(display,gcAnd,0);
    XSetBackground(display,gcAnd,~0);
    XSetGraphicsExposures(display,gcAnd,False);
    
    gcOr = XCreateGC(display,root,0,NULL);
    XSetFunction(display,gcOr,GXor);
    XSetForeground(display,gcOr,~0);
    XSetBackground(display,gcOr,0);
    XSetGraphicsExposures(display,gcOr,False);
    
    gcWhite = XCreateGC(display,root,0,NULL);
    XSetGraphicsExposures(display,gcWhite,False);
    XSetFillStyle(display,gcWhite,FillSolid);
    XSetForeground(display,gcWhite,white);
    
    gcBlack = XCreateGC(display,root,0,NULL);
    XSetGraphicsExposures(display,gcBlack,False);
    XSetFillStyle(display,gcBlack,FillSolid);
    XSetForeground(display,gcBlack,black);
    
    // graphic context - binary version
    Pixmap tmp = XCreatePixmap(display,root,8,8, 1);
    
    gc1 = XCreateGC(display,tmp,0,NULL);
    XSetGraphicsExposures(display,gc1,False);
    
    gc1Copy = XCreateGC(display,tmp,0,NULL);
    XSetGraphicsExposures(display,gc1Copy,False);
    XSetFillStyle(display,gc1Copy,FillOpaqueStippled);
    
    gc1Stippled = XCreateGC(display,tmp,0,NULL);
    XSetGraphicsExposures(display,gc1Stippled,False);
    XSetFillStyle(display,gc1Stippled,FillStippled);
    
    gc1And = XCreateGC(display,tmp,0,NULL);
    XSetFunction(display,gc1And,GXandInverted);
    XSetForeground(display,gc1And,~0);
    XSetBackground(display,gc1And,0);
    XSetGraphicsExposures(display,gc1And,False);
    
    gc1Or = XCreateGC(display,tmp,0,NULL);
    XSetFunction(display,gc1Or,GXor);
    XSetForeground(display,gc1Or,~0);
    XSetBackground(display,gc1Or,0);
    XSetGraphicsExposures(display,gc1Or,False);
    
    gc1White = XCreateGC(display,tmp,0,NULL);
    XSetGraphicsExposures(display,gc1White,False);
    XSetFillStyle(display,gc1White,FillSolid);
    XSetForeground(display,gc1White,white);
    
    gc1Black = XCreateGC(display,tmp,0,NULL);
    XSetGraphicsExposures(display,gc1Black,False);
    XSetFillStyle(display,gc1Black,FillSolid);
    XSetForeground(display,gc1Black,black);

    XFreePixmap(display,tmp);

    XFlush(display);	
}

// ŪФβ
void XsBase::destruct(void) {
    
    // 
    XFreeGC(display,gc1Black);
    XFreeGC(display,gc1White);
    XFreeGC(display,gc1Or);
    XFreeGC(display,gc1And);
    XFreeGC(display,gc1Copy);
    XFreeGC(display,gc1);
    XFreeGC(display,gcBlack);
    XFreeGC(display,gcWhite);
    XFreeGC(display,gcOr);
    XFreeGC(display,gcAnd);
    XFreeGC(display,gcCopy);
    XFreeGC(display,gc);    
    XFlush(display);    
    XCloseDisplay(display);
}

/* ###################################################################
   class XsBaseInit
   쥯饹饹
   ################################################################### */

// 
int XsBaseInit::counter = 0;

// 󥹥ȥ饯
XsBaseInit::XsBaseInit(void) {
    if (counter ++ == 0) { XsBase::construct(); }
}

// ǥȥ饯
XsBaseInit::~XsBaseInit(void) {
    if (-- counter == 0) { XsBase::destruct(); }
}
