#ifndef XsBitmap_H
#define XsBitmap_H

//
// XsBitmap.H
//

// إå
#include <String.h>
#include <X11/xpm.h>

#include <XsSolid.H>
#include <XsImage.H>
#include <XsColor.H>
#include <XsPixmap.H>

// 饹
class XsSolid;
class XsBitmap : public XsSolid {

  public:
    XsBitmap(const String &,const XsColor & = XsColor::defaultWhite);
    ~XsBitmap(void);

public:
    virtual int isChanged(void) const;
    virtual void flushImage(void);
    
public:
    void destroy(void);
    void create(const Vector &);
    void create(const String &);
    void create(const XsBitmap &);
    
    void color(const XsColor &c);
    
    virtual void draw(const XsPixmap &, const Vector &) const;
		          
    Pixmap bitmap(void) const;
    Pixmap mask(void) const;
    
  protected:
    Pixmap _bitmap;

  private:
    unsigned long pixel;
    Pixmap oldbitmap;
    unsigned long oldpixel;

  public:
    static const int xMax;
    static const int yMax;
};

#endif
