#ifndef XsPixmap_H
#define XsPixmap_H

// إå
#include <String.h>
#include <X11/xpm.h>

#include <XsSolid.H>
#include <XsImage.H>

/* ######################################################
   class XsPixmap
   ###################################################### */

class XsSolid;
class XsPixmap : public XsSolid {

public:
    XsPixmap(void);
    XsPixmap(const Vector &,const Vector & = zero);
    XsPixmap(const String &);
    XsPixmap(const XsPixmap &);
    ~XsPixmap(void);

public:
    void destroy(void);
    void create(const Vector &,const Vector & = zero);
    void create(const String &);
    void create(const XsPixmap &);
    void addMask(void);
    
    virtual int isChanged(void) const;
    virtual void flushImage(void);
    
    virtual void draw(const XsPixmap &, const Vector &) const;
		          
    Pixmap pixmap(void) const;
    Pixmap mask(void) const;

protected:
    Pixmap _pixmap, _mask;
    Pixmap oldpixmap;

public:
    static const int xMax;
    static const int yMax;
};

#endif
