//
// XsSprite.C
//

// إå
#include <XsSprite.H>

XsSprite::XsSprite(XsView &v, const XsImage *i,
		   const DVector &vec,
		   const double d,
		   const int s)
: locate(vec), state(s), depth(d), oldlocate(zero), oldstate(0), olddepth(0), view(v), image(i), oldimage(NULL) {
    view.addSprite(this);
}

XsSprite::XsSprite(const XsSprite &s)
: locate(s.locate), state(s.state), depth(s.depth), oldlocate(zero), oldstate(0), olddepth(0), view(s.view), image(s.image), oldimage(NULL) {
    view.addSprite(this);
}

XsSprite::~XsSprite(void) {
    view.removeSprite(this);
}

const Vector XsSprite::top(void) const {
    return Vector(locate)+image->top();
}
const Vector XsSprite::bottom(void) const {
    return Vector(locate)+image->bottom();
}

const Vector XsSprite::mapTop(void) const {
    return top()/view.tileSize;
}
const Vector XsSprite::mapBottom(void) const {
    return bottom()/view.tileSize;
}
const Vector XsSprite::oldmapTop(void) const {
    return oldtop/view.tileSize;
}
const Vector XsSprite::oldmapBottom(void) const {
    return oldbottom/view.tileSize;
}

void XsSprite::flushSprite(void) {
    oldlocate	= Vector(locate);
    oldtop	= top();
    oldbottom	= bottom();
    oldstate	= state;
    olddepth	= depth;
    oldimage	= image;
}

int XsSprite::mustDrawBack(void) const {

    // 褵ƤʤС񤭴ɬפϤʤ
    if (!oldstate) {
	return 0;
    }

    // 褵Ƥ ...
    if (Vector(locate) != oldlocate ||
	depth != olddepth ||
	state != oldstate ||
	image != oldimage ||
	image->isChanged()) {
	return 1;
    } else {
	return 0;
    }
}

int XsSprite::mustDraw(void) const {

   // ɬס
    if (!state) {
        return 0;
    }

    // 褵Ƥ顥
    if (Vector(locate) != oldlocate ||
	depth != olddepth ||
	state != oldstate ||
	image != oldimage ||
	image->isChanged()) {
        return 1;
    } else {
        return 0;
    }
}
