// إå
#include <XsText.H>

//
// XsText.C
//

/* ################################################################
   class XsFont
   ################################################################ */

// Ū
const XsFont XsFont::defaultFont("7x14");

// 󥹥ȥ饯
XsFont::XsFont(const String &f) : fontName(f) {

    fontStruct = XLoadQueryFont(display,fontName);

    if (fontStruct == NULL) {
	cerr << "ERROR !!! : font \"" << fontName << "\" does not exist." << endl;
	exit(1);
    }
}

// ǥȥ饯
XsFont::~XsFont(void) {

    XFreeFont(display,fontStruct);
}

/* ################################################################
   class XsText
   ################################################################ */

// ǥեȤΥե
XsFont f7x14("7x14");

// 󥹥ȥ饯
XsText::XsText(const String &t,int a,const XsFont &f,const XsColor &c) : _anchor(a), _text(""), _color(NULL), _font(NULL), oldanchor(0), oldtext(""),oldcolor(NULL),oldfont(NULL) {
    font(f);
    text(t);
    anchor(a);
    color(c);
}

// 󥹥ȥ饯
XsText::~XsText(void) {}

// եȤλ
void XsText::font(const XsFont &f) {

    if (oldfont == &f && oldfont != NULL) return;
    
    _font = &f;
    
    resetSize();
    resetAnchor();
}

// ƥȤλ
void XsText::text(const String &t) {

    if (_text == t && oldfont != NULL) return;
    
    _text = t;

    resetSize();
    resetAnchor();
}

// 󥫡λ
void XsText::anchor(int a) {

    if (a < 1 || 9 < a) {
	cerr << "ERROR !!! : out of range." << endl;
	exit(1);
    }
    _anchor = a;
    
    resetAnchor();
}


// size
void XsText::resetSize(void) {

    int a1,a2,a3;
    XTextExtents(_font->fontStruct, _text,_text.length(),
		 &a1, &a2, &a3, &charStruct);
    _size = Vector(charStruct.width + 1,
		   charStruct.ascent + charStruct.descent + 1);
}

// anchor
void XsText::resetAnchor(void) {

    
    switch ((_anchor - 1) / 3) {
      case 0:
	_hots.y = _size.y;
	break;
      case 1:
	_hots.y = _size.y / 2;
	break;
      case 2:
	_hots.y = 0;
	break;
    }
    switch ((_anchor - 1) % 3) {
      case 0:
	_hots.x = 0;
	break;
      case 1:
	_hots.x = _size.x / 2;
	break;
      case 2:
	_hots.x = _size.x;
	break;
    }
}

// λ
void XsText::color(const XsColor &c) {
    _color = &c;
}

// ɽ
void XsText::draw(const XsPixmap &p,const Vector &v) const {

    int xx = v.x - _hots.x;
    int yy = v.y - _hots.y + charStruct.ascent;
     
    XSetForeground(display,gc,_color->color.pixel);
    XSetFont(display,gc,_font->fontStruct->fid);
    XDrawString(display, p.pixmap(), gc,
		xx, yy, _text, _text.length());
}

// 줿
int XsText::isChanged(void) const {

    return (oldanchor != _anchor ||
	    oldtext != _text ||
	    oldcolor != _color ||
	    oldfont != _font ||
	    XsSolid::isChanged());
}

// 
void XsText::flushImage(void) {

    oldanchor = _anchor;
    oldtext = _text;
    oldcolor = _color;
    oldfont = _font;

    XsSolid::flushImage();    
}
