#ifndef XsText_H
#define XsText_H

//
// XsText.H
//

// إå
#include <String.h>
#include <X11/xpm.h>

#include <XsImage.H>
#include <XsSolid.H>
#include <XsPixmap.H>
#include <XsColor.H>

/* ################################################################
   class XsFont
   ################################################################ */

// 饹
class XsFont : public XsBase {

friend class XsText;
    
  public:
    XsFont(const String & = "7x14");
    ~XsFont(void);
    
  protected:
    String fontName;

  private:
    XFontStruct *fontStruct;
    
  public:
    static const XsFont defaultFont;
};

/* ################################################################
   class XsText
   ################################################################ */

// 饹
class XsText : public XsSolid {

  public:
    XsText(const String & = "NoText",
	   int = 5,
	   const XsFont & = XsFont::defaultFont,
	   const XsColor & = XsColor::defaultWhite);
    ~XsText(void);

    virtual void draw(const XsPixmap &, const Vector &) const;

public:
    virtual int isChanged(void) const;
protected:
    virtual void flushImage(void);

public:
    void font(const XsFont & = XsFont::defaultFont);
    void text(const String & = "NoText");
    void anchor(int);
    void color(const XsColor & = XsColor::defaultWhite);
  protected:
    void resetSize(void);
    void resetAnchor(void);
    
  private:
    int _anchor;
    String _text;
    const XsColor *_color;
    const XsFont *_font;

    int oldanchor;
    String oldtext;
    const XsColor *oldcolor;
    const XsFont *oldfont;

    XCharStruct charStruct;
};

#endif
