#ifndef XsView_H
#define XsView_H

//
// XsView.H
//

// إå
#include <List.H>
#include <XsPixmap.H>
#include <XsSprite.H>
#include <XsWindow.H>

#include <X11/xpm.h>

/* #####################################################################
   class XsView
   ##################################################################### */

class XsSprite;
class XsView : public XsPixmap {

  public:
    XsView(const Window &,
	   const Vector &,
	   const int = 1);			// 󥹥ȥ饯
    ~XsView(void);				// ǥȥ饯

  public:
    void refresh(void);				// ɽ
    static void refreshAll(void);		// Viewζɽ
  private:
    void redraw(void);				// Ϫʬɽ
  private:
    const int _redraw;				// Ϫʬɽե饰

  private:
    int getState(const XsSprite *);		// ץ饤Ȥʬμ
    void setState(const XsSprite *,int);	// ץ饤Ȥʬ
    void setOldState(const XsSprite *,int);	// ץ饤Ȥʬ

  public:
    void showState(void);			// ǥХ
    
  public:
    const XsImage * &map(const Vector &);	// ޥåפ
  protected:
    const XsImage * &oldmap(const Vector &);	// Υޥåפ
    int &state(const Vector &);			// 
  private:
    const XsImage ***_map;			// ޥå
    const XsImage ***_oldmap;			// Υޥå
    int **_state;				// 

  public:
    void addSprite(XsSprite *);			// ץ饤Ȥɲ
    void removeSprite(XsSprite *);		// ץ饤Ȥκ

  public:
    const Window window;
    const Vector tileSize;
    const Vector &mapSize(void) const;
    const Vector mapTop(void) const;
    const Vector mapBottom(void) const;
  public:
    Set <XsSprite *> setSprite;
  protected:
    Vector _mapSize;
    int mapArray;

  public:
    const int numChangedTiles(void) const;
    const int numChangedAreas(void) const;
    int isFillUnchangedTiles;
  private:
    int _numChangedTiles;
    int _numChangedAreas;
    
  public:
    void flushView(void);			// ʬɽ
    static void flushAllView(void);		// Viewι
  private:
    static Set <XsView *> setView;
};

#endif
