// إå
#include <XsWindow.H>

/* #####################################################################
   class XsWindow
   ##################################################################### */

// 󥹥ȥ饯
XsWindow::XsWindow(const Vector &v,const String &name,int s) : _state(0) {

    _window = XCreateSimpleWindow(display,root,
				  0,0,
				  v.x,v.y,
				  0,
				  white,black);
    XSelectInput(display,_window,ExposureMask);
    XStoreName(display,_window,name);
    XFlush(display);

    state(s);
}

XsWindow::~XsWindow(void) {

    state(0);
    
    // ˲
    XDestroyWindow(display,_window);
    XFlush(display);
}

XsWindow::operator Window(void) const {

    return _window;
}

void XsWindow::state(int s) {
    
    if (!_state && s) {

	XMapWindow(display,_window);
	XFlush(display);
	
    } else if (_state && !s) {

	XUnmapWindow(display,_window);
	XFlush(display);
    }

    _state = s;
}

/* #####################################################################
   class XsMultiWindow
   ##################################################################### */

// 󥹥ȥ饯
XsMultiWindow::XsMultiWindow(const Vector &v,const String &name,int s) : _state(0) {
    _window = XCreateSimpleWindow(display,root,
				  0,0,
				  v.x,v.y,
				  0,
				  white,black);
    XSelectInput(display,_window,ExposureMask);
    XStoreName(display,_window,name);
    XFlush(display);

    state(s);
}

XsMultiWindow::~XsMultiWindow(void) {

    state(0);
    
    // ˲
    XDestroyWindow(display,_window);
    XFlush(display);
}

Window XsMultiWindow::operator [](int id) {

    return list[id];
}

void XsMultiWindow::state(int s) {
    
    if (!_state && s) {

	XMapWindow(display,_window);
	XFlush(display);
	
    } else if (_state && !s) {

	XUnmapWindow(display,_window);
	XFlush(display);
    }

    _state = s;
}

void XsMultiWindow::create(int id,const Vector &t,const Vector &s) {

    list[id] = XCreateSimpleWindow(display,_window,
				   t.x,t.y,
				   s.x,s.y,
				   0,
				   white,black);
    XSelectInput(display,list[id],
		 ExposureMask);
    XMapWindow(display,list[id]);
    XFlush(display);
}

void XsMultiWindow::destroy(int id) {

    // ˲
    XDestroyWindow(display,list[id]);
    XFlush(display);
    list.remove(id);
}
